--LOAD
myWorld:addClass("ObjectA")
myWorld:addClass("ObjectB")

--pot starting position
for k, object in pairs(map.objects) do
    if object.name == "Pot" then
        pot = object
        break
    end
end
--box starting position
for k, object in pairs(map.objects) do
    if object.name == "Box" then
        box = object
        break
    end
end
--chair starting setPosition
for k, object in pairs(map.objects) do
    if object.name == "Chair" then
        chair = object
        break
    end
end
--custom layers
ou = map:addCustomLayer("ObjectsUp",3)
od = map:addCustomLayer("ObjectsDown",3)

--create pot object
ou.pot = {}
  ou.pot.ox = pot.width/2
  ou.pot.oy = pot.height/2
  ou.pot.collider =  myWorld:addCircle(
  pot.x + ou.pot.ox,
  pot.y - ou.pot.oy,
  pot.width/3
  )
  ou.pot.collider:setFixedRotation(true)
  ou.pot.collider:setFriction(0.05)
  ou.pot.collider:setDensity(4)
  ou.pot.collider:resetMassData()
  ou.pot.collider:setClass("ObjectA") --normal dynamic object

  --create box object
  ou.box = {}
    ou.box.ox = box.width/2
    ou.box.oy = box.height/2
    ou.box.collider =  myWorld:addRectangle(
    box.x + ou.box.ox,
    box.y - ou.box.oy,
    box.width,
    box.height
    )
    ou.box.collider:setFixedRotation(true)
    ou.box.collider:setFriction(0.3)
    ou.box.collider:setDensity(6)
    ou.box.collider:resetMassData()
    ou.box.collider:setClass("ObjectA") --normal dynamic objcets

    --create chair object
  od.chair = {}
    od.chair.ox = chair.width/2
    od.chair.oy = chair.height/2
    od.chair.collider =  myWorld:addRectangle(
    chair.x + od.chair.ox,
    chair.y - od.chair.oy,
    chair.width/2,
    chair.height/2
    )
    od.chair.collider:setType("static")
    od.chair.collider:setClass("ObjectB") --static but still an objcet

--DRAW
ou.draw = function(self)
--draw ordinary objects behind the player
love.graphics.draw(
sprites.pot,self.pot.collider:getX(),self.pot.collider:getY(),
0,1,1,self.pot.ox,self.pot.oy
)
self.pot.collider:setLinearVelocity(0, 0) --stop pot if nothing moves it
love.graphics.draw(
sprites.box,self.box.collider:getX(),self.box.collider:getY(),
0,1,1,self.box.ox,self.box.oy
)
self.box.collider:setLinearVelocity(0, 0) --stop box if nothing moves it
end

od.draw = function(self)
love.graphics.draw(
sprites.chair,self.chair.collider:getX(),self.chair.collider:getY(),
0,1,1,self.chair.ox,self.chair.oy
)
end

--shadows drawn under other outside layers but over D1 ground
function object_shadows()
  --pot shadows
  love.graphics.setColor(0,0,0,0.5)
  love.graphics.ellipse(
  "fill",
  ou.pot.collider:getX(),
  ou.pot.collider:getY() + 5,
  8,
  4
  )
  love.graphics.setColor(1,1,1,1)
end
