myWorld:addClass("Player", {"ObjectB"})

--hero start position
for k, object in pairs(map.objects) do
    if object.name == "Player" then
        player = object
        break
    end
end

--custom layers
p = map:addCustomLayer("Player",3)
--create player object
p.player = {}
  p.player.ox = player.width/2
  p.player.oy = player.height/1.5
  p.player.collider =  myWorld:addCircle(
  player.x + p.player.ox,
  player.y + player.height/2,
  player.width/4
  )
  p.player.vx = 0
  p.player.vy = 0
  p.player.direction = "south"
  p.player.state = "standing"
  p.player.speed = 16*4
  p.player.collider:setFixedRotation(true)
  p.player.collider:setClass("Player") --player object ignores static objects

  --UPDATE
  p.update = function(self, dt)
        --movement
    if love.keyboard.isDown("w","up") then
        self.player.vy = -1
        self.player.direction = "north"
    elseif love.keyboard.isDown("s","down") then
        self.player.vy = 1
        self.player.direction = "south"
    else
        self.player.vy = 0
    end
    if love.keyboard.isDown("a","left") then
        self.player.vx = -1
        self.player.direction = "west"
    elseif love.keyboard.isDown("d","right") then
        self.player.vx = 1
        self.player.direction = "east"
    else
        self.player.vx = 0
    end
    --control player state
    self.player.collider:setPostsolve(function(s1,s2)
        if s2:getClass() == "ObjectA" then
            self.player.state = "pushing"
        end
    end)
    if self.player.vx == 0 and self.player.vy == 0 then
      self.player.state = "standing"
    else
      self.player.state = "walking"
    end
    --update player velocity
    self.player.collider:setLinearVelocity(
    self.player.vx * self.player.speed,
    self.player.vy * self.player.speed
    )
    --math.floor fixes the shaking camera and locks onto integer values only
    cam:setPosition(
    math.floor(self.player.collider:getX()),
    math.floor(self.player.collider:getY())
    )
  end

  p.draw = function(self)
  local pose = sprites.stand_cycle --default pose when nothing has been pressed
  --draw the player over everything else
    if player_state() == "pushing" then
      pose = sprites.player_pushing
    elseif player_state() == "walking" then
      pose = sprites.player_walking
    elseif player_state() == "standing" then
      pose = sprites.player_standing
    end
    --direction is handled here (1 = south, 2 = west, 3 = east, 4 = north)
    if self.player.direction == "south" then
      hero[1]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
      0,1,1,self.player.ox,self.player.oy)
    end
    if self.player.direction == "west" then
      hero[2]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
      0,1,1,self.player.ox,self.player.oy)
    end
    if self.player.direction == "east" then
      hero[3]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
      0,1,1,self.player.ox,self.player.oy)
    end
    if self.player.direction == "north" then
      hero[4]:draw(pose, math.floor(self.player.collider:getX()), math.floor(self.player.collider:getY()),
      0,1,1,self.player.ox,self.player.oy)
    end
  end

  function player_state()
      p.player.collider:setEnter(function(s1,s2,c,i)
          if s2:getClass() == "ObjectA" and
          (p.player.vx > 0 or p.player.vy > 0)
          then
              p.player.state = "pushing"
          end
      end)
      p.player.collider:setExit(function(s1,s2,c,i)
          if s2:getClass() == "ObjectA" and
          (p.player.vx > 0 or p.player.vy > 0)
          then
              p.player.state = "walking"
          elseif p.player.vx == 0 and p.player.vy == 0 then
              p.player.state = "standing"
          end
      end)
      return p.player.state
  end

  function player_shadows()
    --player shadow
    love.graphics.setColor(0,0,0,0.5)
    love.graphics.ellipse(
    "fill",
    p.player.collider:getX(),
    p.player.collider:getY() + 5,
    6,
    3
    )
    love.graphics.setColor(1,1,1,1)
  end
